PROGRAM Main
  USE Class_Wavelet
  USE Class_Statistic
  IMPLICIT NONE
  INTEGER         , PARAMETER   :: iMax         = 192          ! Number of point on x grid
  INTEGER         , PARAMETER   :: jMax         =  96          ! Number of point on xygrid
  INTEGER         , PARAMETER   :: nVar         = 1            ! Number of variables
  REAL(KIND=r8)                 :: undef=-9.9900000E+08                 ! undef value

!    REAL(KIND=r4)   , ALLOCATABLE :: sst           (:,:,:)     ! dados para calcular a wavelets
  REAL(KIND=r4)   , ALLOCATABLE :: sst3d         (:,:,:)     ! dados para calcular a wavelets
!  REAL(KIND=r8)   , ALLOCATABLE :: Sd_SigmaX     (:,:)   
!  REAL(KIND=r8)   , ALLOCATABLE :: AvE_barX      (:,:) 
!    REAL(KIND=r4)   , ALLOCATABLE :: sst1ave       (:,:,:)
!  REAL(KIND=r8)   , ALLOCATABLE :: sst1d         (:)
!  REAL(KIND=r8)   , ALLOCATABLE :: Recon_sst     (:,:,:)
!    REAL(KIND=r8)   , ALLOCATABLE :: Recon_sst2    (:,:,:)
!    REAL(KIND=r8)   , ALLOCATABLE :: Filter_sstENSO(:,:,:)
!    REAL(KIND=r8)   , ALLOCATABLE :: SCALE         (:,:,:)  ! the wavelet scale used to construct the daughter.
!    COMPLEX(KIND=r8), ALLOCATABLE :: wave          (:,:,:,:)!  wave = 2D array of the real & imaginary parts
  !  of the wavelet transform, versus time & scale.
  !  CABS(wave) gives the WAVELET amplitude,
  !  ATAN2(AIMAG(wave),DBLE(wave)) gives WAVELET phase.
  !  The WAVELET power spectrum is CABS(wave)**2.
!    REAL(KIND=r8)   , ALLOCATABLE :: period         (:,:,:) ! the "Fourier" periods (in time units) corresponding to "scale".
!    REAL(KIND=r8)   , ALLOCATABLE :: Cdelta         (:,:)   ! the constant "Cdelta" for the mother wavelet (Table 2).
!    REAL(KIND=r8)   , ALLOCATABLE :: coi            (:,:,:) ! the e-folding factor used for the cone of influence.
!    REAL(KIND=r8)   , ALLOCATABLE :: signif         (:,:,:) ! significance levels vs scale.
  ! IF SIGTEST=2, then signif(1) = the significance level
  !  signif(2...jtot) = 0.0
!    REAL(KIND=r8)   , ALLOCATABLE :: global_ws      (:,:,:)
!    REAL(KIND=r8)   , ALLOCATABLE :: global_signif  (:,:,:)
!    REAL(KIND=r8)   , ALLOCATABLE :: P_theor        (:,:,:) ! theoretical red-noise spectrum vs scale.
  ! IF SIGTEST=2, then fft_theor(1) = the average spectrum from S1-->S2
  ! fft_theor(2...jtot) = 0.0
!    REAL(KIND=r8)   , ALLOCATABLE :: fft_theor      (:,:,:) ! theoretical red-noise spectrum vs scale.
  ! IF SIGTEST=2, then fft_theor(1) = the average spectrum from S1-->S2
  ! fft_theor(2...jtot) = 0.0
!    REAL(KIND=r8)   , ALLOCATABLE :: savg_dof       (:,:,:)!degrees-of-freedom that were actually used.
!    REAL(KIND=r8)   , ALLOCATABLE :: savg_signif    (:,:,:)
  REAL(KIND=r8)    :: DIURNALCYCLE(24)
  INTEGER :: i
  INTEGER :: j,k
  INTEGER :: lrec
  INTEGER :: irec
  INTEGER :: iano
  INTEGER :: itime
  INTEGER :: imes
  INTEGER :: ivar,jtotal,ncount
  CHARACTER(LEN=20) :: data1
  CHARACTER(LEN=20) :: char
  REAL(KIND=r8)    :: p0,ss0,p1,ss1,sjtotal,spec,per,pjtot
  CHARACTER (LEN=20),ALLOCATABLE :: cdate(:)
  CHARACTER (LEN=20),ALLOCATABLE :: ctime(:)
  CHARACTER (LEN=2) :: clevels

  CALL Init()  
  CALL Run()
  CALL Finalize()

CONTAINS
  SUBROUTINE Init()
    IMPLICIT NONE
    REAL(KIND=r8)       :: u0,u1,u2,u3,u4,u5,u6,u7,u8,u9
    REAL(KIND=r4)       :: aux(iMax,jMax)
    REAL(KIND=r4)       :: auxt(nTime)

    INTEGER             :: irec,lrec,it,i,j
    CALL Init_Wavelet()
    PRINT*,'read',jtot,iMax,jMax,nTime
    !
    !** read in the NINO3 SST data
    !   The seasonal means for the entire record have been removed to define an anomaly time series
    ALLOCATE(cdate         (          nTime          ))
    ALLOCATE(ctime         (          nTime          ))
!    ALLOCATE(sst1d         (          nTime          ))

!PK    ALLOCATE(sst1ave       (iMax,jMax,nTime       ))
    ALLOCATE(sst3d         (iMax,jMax,nTime     ))
!    ALLOCATE(sst           (iMax,jMax,nTime     ))
!PK   ALLOCATE(AvE_barX      (iMax,jMax))
!PK   ALLOCATE(Recon_sst     (iMax,jMax,nTime     ))
!PK   ALLOCATE(Recon_sst2    (iMax,jMax,nTime     ))
!PK   ALLOCATE(Filter_sstENSO(iMax,jMax,nTime     ))
!PK   ALLOCATE(SCALE         (iMax,jMax,jtot))
!PK   ALLOCATE(period        (iMax,jMax,jtot))
!PK   ALLOCATE(Cdelta        (iMax,jMax))
!PK   !ALLOCATE(coi           (iMax,jMax,nTime))
!PK   ALLOCATE(signif        (iMax,jMax,jtot))
!PK   ALLOCATE(global_ws     (iMax,jMax,jtot))
!PK   ALLOCATE(global_signif (iMax,jMax,jtot))
!PK   ALLOCATE(fft_theor     (iMax,jMax,jtot))
!PK   ALLOCATE(P_theor       (iMax,jMax,jtot))
!PK   ALLOCATE(savg_dof      (iMax,jMax,jtot))
!PK   ALLOCATE(savg_signif   (iMax,jMax,jtot))
!    ALLOCATE(wave          (iMax,jMax,nTime,jtot))
!STOP
!"2014-07-25"   "19:00:00.00"   0.08100  -0.10150  -0.17025  -0.05075   0.01800   0.06500   0.39900   0.45825   0.70650   0.86425 
    INQUIRE(IOLENGTH=lrec) aux
    OPEN(11,FILE=TRIM(FileNameIn)//'/'//'NOAA_ROLE.bin',FORM='UNFORMATTED'&
        ,ACCESS='DIRECT',RECL=lrec,STATUS='OLD',ACTION='READ')
    irec=0
    DO it=1,ntime
       irec=irec+1
       READ(11,rec=irec)aux
       sst3d(:,:,it)=aux
    END DO
    PRINT*,MAXVAL(sst3d),MINVAL(sst3d)
    CLOSE(11)    
    DO it=1,ntime 
       DO j=1,jMax
          DO i=1,iMax
             IF(sst3d(i,j,it) == undef)THEN
	        sst3d(i,j,it)=273.16
             END IF 
          END DO
      END DO
    END DO
    PRINT*,MAXVAL(sst3d),MINVAL(sst3d)

!PK    OPEN(UNIT=11,FILE=TRIM(FileNameIn)//'/'//'data.txt',STATUS='old')
!PK    READ(11,"(1x)")
!PK    DO k=1,nTime
!PK       READ(11,*)cdate(k),ctime(k), u0
!PK          sst1d(k)=u0
!PK    END DO
!PK    CLOSE(11)
    PRINT'(/,"sst(1)=",F6.2,"  sst(n) = ",F6.2,/)',sst3d(1,1,1),sst3d(1,1,nTime)
    PRINT'(/,"sst(1)=",F6.2,"  sst(n) = ",F6.2,/)',sst3d(imax,jMax,1),sst3d(imax,jMax,nTime)
    PRINT'(/,"sst(1)=",F6.2,"  sst(n) = ",F6.2,/)',sst3d(imax,1,1),sst3d(imax,1,nTime)
    PRINT'(/,"sst(1)=",F6.2,"  sst(n) = ",F6.2,/)',sst3d(1,jMax,1),sst3d(1,jMax,nTime)
! MENOR ESCALA POSSIVEL

    p0 = 2.0*dt
    ss0 = p2s(p0)
    PRINT *, 'MENOR ESCALA POSSIVEL = ',ss0
! MAIOR ESCALA POSSIVEL
      p1 = REAL(nTime)*dt
      ss1 = p2s(p1)
      PRINT *, 'MAIOR ESCALA POSSIVEL = ',ss1
! OBTENCAO DE JTOT (# DE ESCALAS) E NCOUNT (# DE ESCALAS NO PERIODO DE INTERESSE)
      PRINT '(a6,2x,a8,2x,a5,2x,a5)', 'dj', 'Pmax', 'jtot', 'N' !Pmax = p(jtot), N = ncount
      DO i = 0, 19
         dj = 0.5 - REAL(i)*0.025
         jtotal = int(1.0/dj) * int ( log(ss1/ss0) / log(2.0_r8) ) !Eq. 10
         sjtotal = s0 * 2.0**(jtotal*dj)                          !Eq. 9
         pjtot = p2s(sjtotal)
         ncount = 0
         DO j = 1, jtot
            spec = ss0 * 2.0**(j*dj) !Eq. 9
            per = s2p(spec)
            IF ((per.ge.scalemin).and.(per.le.scalemax)) ncount = ncount + 1
         END DO
         PRINT '(f15.3,2x,f15.1,2x,i5,2x,i5)', dj, pjtot, jtotal, ncount
      END DO
 
 
  END SUBROUTINE Init

  SUBROUTINE Run()
    IMPLICIT NONE
    INTEGER :: i
    INTEGER :: ii
    INTEGER :: j
    INTEGER :: jj
    INTEGER :: k
    INTEGER :: ivar
    INTEGER :: lrec
    INTEGER :: irec
    INTEGER, PARAMETER          :: nvars=3
    REAL(KIND=r4)               :: aux           (iMax,jMax)
    REAL(KIND=r8)               :: coi2          (1:nTime)
    REAL(KIND=r4)               :: AvE_barX      (iMax,jMax)
    REAL(KIND=r4)               :: Sd_SigmaX     (iMax,jMax)
!    REAL(KIND=r4)               :: sst1ave       (iMax,jMax,nTime)
!    REAL(KIND=r4)               :: sst           (iMax,jMax,nTime)
    REAL(KIND=r4)               :: Recon_sst     (nTime)
    REAL(KIND=r4)               :: Recon_sst2    (nTime)
    REAL(KIND=r4)               :: Filter_sstENSO(iMax,jMax,nTime)
    COMPLEX(KIND=r8)            :: wave2         (1:nTime,1:jtot)
    REAL(KIND=r8)               :: SCALE         (jtot)
    REAL(KIND=r8)               :: period        (jtot)
    REAL(KIND=r8)               :: Cdelta        
    REAL(KIND=r8)               :: signif        (jtot)
    REAL(KIND=r8)               :: global_ws     (jtot)
    REAL(KIND=r8)               :: savg_signif   (jtot)
    REAL(KIND=r8)               :: fft_theor     (jtot)
    REAL(KIND=r8)               :: P_theor       (jtot)
    REAL(KIND=r8)               :: global_signif (jtot)
    REAL(KIND=r8)               :: savg_dof      (jtot)
    CHARACTER(LEN=1)::asp='"'
    !REAL(KIND=r8)              :: ylevs(ydim)=0.00_r8
    REAL(KIND=r8)               :: xdim0      =   0.00_r8
    REAL(KIND=r8)               :: ydim0      = -90.00_r8
    REAL(KIND=r8)               :: xdimdelta  = 360.0_r8/iMax
    REAL(KIND=r8)               :: ydimdelta  = 180.0_r8/jMax
    xdimdelta  = 360.0_r8/iMax
    ydimdelta  = 180.0_r8/jMax

    xdim0   =   0.00_r8
    ydim0   = -90.00_r8+(ydimdelta/2.0_r8)
       DO j=1,jMax
          DO i=1,iMax
             IF(ANY(sst3d(i,j,:) /= undef))THEN
                     AvE_barX(i,j)  = AVE(REAL(sst3d(i,j,1:nTime),KIND=r8))
                     !Sd_SigmaX(i,j)  = 1.0_r8
                     !sst1ave(i,j,1:nTime) = AvE_barX(i,j)
                     sst3d(i,j,1:nTime) =	sst3d(i,j,1:nTime)-AvE_barX(i,j)
                 PRINT*,MAXVAL(sst3d(i,j,1:nTime)+AvE_barX(i,j)),MINVAL(sst3d(i,j,1:nTime)+AvE_barX(i,j))
                 
                CALL Run_Wavelet(&
                     REAL(sst3d           (i,j,1:nTime),KIND=r8) , &
                     Recon_sst            (1:nTime)              , &!reconstruct the time series between 1 and jtot [Eq. 11]
                     Recon_sst2           (1:nTime)              , &!reconstruct the time series between 'javg1' and 'javg2' [Eq. 29]
                     Filter_sstENSO       (i,j,1:nTime)          , &!reconstruct the time series between 'javg1' and 'javg2' [Eq. 29]
                     wave2                (1:nTime,1:jtot)       , &
                     SCALE                (1:jtot)               , &
                     period               (1:jtot)               , &
                     Cdelta                                      , &
                     coi2                 (1:nTime)              , &
                     signif               (1:jtot)               , &
                     global_ws            (1:jtot)               , &
                     global_signif        (1:jtot)               , &
                     fft_theor            (1:jtot)               , &
                     P_theor              (1:jtot)               , &
                     savg_dof             (1:jtot)               , &
                     savg_signif          (1:jtot)               &
                     )
                     Filter_sstENSO       (i,j,1:nTime)=Recon_sst(1:nTime)+AvE_barX(i,j) - &
                     ((sst3d(i,j,1:nTime)+AvE_barX(i,j)) - (Recon_sst2(1:nTime)+AvE_barX(i,j))) 
                   print*,i,j,MAXVAL(Recon_sst2(1:nTime)+AvE_barX(i,j)),&
		              MINVAL(Recon_sst2(1:nTime)+AvE_barX(i,j))
             END IF
          END DO
       END DO
    WRITE(*,*)'DUMPING'
    WRITE(clevels(1:2),'(I2.2)')zlevel

    INQUIRE(IOLENGTH=lrec) aux(:,:)
    OPEN(100,FILE=TRIM(FileNameOut)//'data_filter_'//TRIM(clevels)//'.bin',FORM='UNFORMATTED',ACCESS='DIRECT',RECL=lrec,STATUS='UNKNOWN',ACTION='WRITE')
    irec=0
    DO i=1,nTime
         !WRITE(*,*)'dump grads files ',i

!       DO ivar=1,nVar

          ! input time series

!          irec=irec+1
!          WRITE(100,rec=irec) REAL((sst(:,:,i)*Sd_SigmaX(:,:))+sst1ave(:,:,i),KIND=r4)

          ! reconstructed time series

!          irec=irec+1
!          WRITE(100,rec=irec) REAL((Recon_sst(:,:,i)*Sd_SigmaX(:,:))+sst1ave(:,:,i),KIND=r4)

          !  filtered time series reconstruct the time series between 'javg1' and 'javg2'

          irec=irec+1
          WRITE(100,rec=irec) REAL((Filter_sstENSO(:,:,i)),KIND=r4)

          !  filtered time series in windows

          irec=irec+1
          WRITE(100,rec=irec) REAL((sst3d(:,:,i)+AvE_barX(:,:)),KIND=r4) 



!PK         ! scale-averaged wavelet power and significance
!PK
!PK
!PK         irec=irec+1
!PK         WRITE(100,rec=irec) REAL( savg_signif  (:,:,1),KIND=r4)
!PK
!PK         ! amplitude
!PK
!PK         DO j=jtot,1,-1
!PK            irec=irec+1
!PK            WRITE(100,rec=irec)REAL(ABS(wave(:,:,i,j)*CONJG(wave(:,:,i,j))),KIND=r4)
!PK         END DO
!PK
!PK         ! real part
!PK
!PK         DO j = jtot, 1, -1
!PK            irec = irec + 1
!PK            WRITE(100,rec=irec)REAL(ABS(wave(:,:,i,j))**2,KIND=r4)
!PK         END DO
!PK
!PK         ! local significance
!PK
!PK         DO j=jtot,1,-1
!PK            irec=irec+1
!PK            WRITE(100,rec=irec) REAL(signif(:,:,j),KIND=r4)
!PK         END DO
!PK
!PK         !  coi mask
!PK
!PK         DO j=jtot,1,-1
!PK            aux=0.0_r4
!PK            DO jj=1,jMax
!PK               DO ii=1,iMax
!PK                  IF (period        (ii,jj,j) <= coi(ii,jj,i)) THEN
!PK                     aux(ii,jj) = 1.0
!PK                  ELSE
!PK                     aux(ii,jj) = -1.0
!PK                  END IF
!PK               END DO
!PK            END DO
!PK            irec = irec+1
!PK            WRITE(100,rec=irec) REAL( aux,KIND=r4)
!PK         END DO
!PK
!PK         ! global wavelet power
!PK
!PK         DO j=jtot,1,-1
!PK            irec=irec+1
!PK            WRITE(100,rec=irec) REAL(global_ws(:,:,j),KIND=r4)
!PK         END DO
!PK
!PK         ! global significance
!PK
!PK         DO j=jtot,1,-1
!PK            irec=irec+1
!PK            WRITE(100,rec=irec) REAL(global_signif(:,:,j),KIND=r4)
!PK         END DO
!PK
!PK
!       END DO
    END DO

    OPEN(101,FILE=TRIM(FileNameOut)//'data_filter_'//TRIM(clevels)//'.ctl',FORM='FORMATTED',ACCESS='SEQUENTIAL',STATUS='UNKNOWN',ACTION='WRITE')
    WRITE(101,'(A8,A                 )')'dset    ',TRIM(FileNameOut)//'data_filter_'//TRIM(clevels)//'.bin'
    WRITE(101,'(A8,A21               )')'title   ','file created by grads'
    WRITE(101,'(A8,A15                )')'options ',' '
    WRITE(101,'(A8,e15.6             )')'undef   ',undef
    WRITE(101,'(A8,i5,A11,F15.6,F15.6)')'XDEF    ',iMax,' LINEAR    ',xdim0 ,xdimdelta
    WRITE(101,'(A8,i5,A11,F15.6,F15.6)')'YDEF    ',jMax,' LINEAR    ',ydim0 ,ydimdelta
    WRITE(101,'(A8,i5,A11            )')'ZDEF    ',jtot-jtot+1,' LEVELS   1 '
    WRITE(101,'(A8,i15,A11,A15,A2,A5 )')'TDEF    ',nTime   ,' LINEAR    ',TRIM(tctl),'  ',TRIM(dectl)
    WRITE(101,'(A8,i5                )')'vars    ',nvars 
    DO ivar=1,nvar
       IF(ivar == 1)THEN
!          WRITE(101,'(A10,A5,A5,A51        )')'varori    ','  0  ','   99',' Original time series (unit)                       '
!          WRITE(101,'(A10,A5,A5,A51        )')'varrec    ','  0  ','   99',' Reconstructed time series (unit)                  '
          WRITE(101,'(A10,A5,A5,A51        )')'varfil    ','  0  ','   99',' Filtered time series                  ( unit)     '
          WRITE(101,'(A10,A5,A5,A51        )')'datafil   ','  0  ','   99',' Filtered time series scalemin-scalemax( unit)     '
!          WRITE(101,'(A10,A5,A5,A51        )')'sawpsig   ','  0  ','   99',' SAWP significance (unit^2)                        '
!          WRITE(101,'(A10,i5,A5,A51        )')'amplitude ',jtot   ,'   99',' Amplitude (unit)                                  '
!          WRITE(101,'(A10,i5,A5,A51        )')'real      ',jtot   ,'   99',' Real part (unit)                                  '
!          WRITE(101,'(A10,i5,A5,A51        )')'slocal    ',jtot   ,'   99',' Local significance (unit^2)                       '
!          WRITE(101,'(A10,i5,A5,A51        )')'mask      ',jtot   ,'   99',' Coi mask (-1 or +1)                               '
!          WRITE(101,'(A10,i5,A5,A51        )')'global    ',jtot   ,'   99',' Global wavelet spectrum (unit^2)                  '
!          WRITE(101,'(A10,i5,A5,A51        )')'sglobal   ',jtot   ,'   99',' Global significance (unit^2)                      '
       ELSE IF(ivar == 2)THEN
!          WRITE(101,'(A10,A5,A5,A51        )')'varori2   ','  0  ','   99',' Original time series (unit)                       '
!          WRITE(101,'(A10,A5,A5,A51        )')'varrec2   ','  0  ','   99',' Reconstructed time series (unit)                  '
          WRITE(101,'(A10,A5,A5,A51        )')'varfil2   ','  0  ','   99',' Filtered time series scalemin-scalemax( unit)     '
          WRITE(101,'(A10,A5,A5,A51        )')'datafil2   ','  0  ','   99',' Filtered time series scalemin-scalemax( unit)     '
!          WRITE(101,'(A10,A5,A5,A51        )')'sawpsig2  ','  0  ','   99',' SAWP significance (unit^2)                        '
!          WRITE(101,'(A10,i5,A5,A51        )')'amplitude2',jtot   ,'   99',' Amplitude (unit)                                  '
!          WRITE(101,'(A10,i5,A5,A51        )')'real2     ',jtot   ,'   99',' Real part (unit)                                  '
!          WRITE(101,'(A10,i5,A5,A51        )')'slocal2   ',jtot   ,'   99',' Local significance (unit^2)                       '
!          WRITE(101,'(A10,i5,A5,A51        )')'mask2     ',jtot   ,'   99',' Coi mask (-1 or +1)                               '
!          WRITE(101,'(A10,i5,A5,A51        )')'global2   ',jtot   ,'   99',' Global wavelet spectrum (unit^2)                  '
!          WRITE(101,'(A10,i5,A5,A51        )')'sglobal2  ',jtot   ,'   99',' Global significance (unit^2)                      '
       END IF
    END DO
    WRITE(101,'(A7                         )')'endvars'


  END SUBROUTINE Run

!
! ----------------------------------------------------------------------
!
   FUNCTION p2s (period) !Morlet
      REAL(KIND=r8)  ,INTENT(IN) :: period
      REAL(KIND=r8)  , PARAMETER :: omega0=6.0
      REAL(KIND=r8)  , PARAMETER ::  pi =3.14159
      REAL(KIND=r8)  ::   factor,p2s
      factor = 4.0*pi / ( omega0 + sqrt(2.0 + omega0**2) )
      p2s = period/factor
    RETURN
  END FUNCTION p2s 

  FUNCTION s2p (scale) !Morlet
      REAL(KIND=r8)  ,INTENT(IN) :: scale
      REAL(KIND=r8)  , PARAMETER :: omega0=6.0
      REAL(KIND=r8)  , PARAMETER ::  pi =3.14159
      REAL(KIND=r8)   :: factor,s2p
      factor = 4.0*pi / ( omega0 + sqrt(2.0 + omega0**2) )
      s2p = scale*factor
      RETURN
  END FUNCTION s2p 



  SUBROUTINE Finalize()
    IMPLICIT NONE
!    DEALLOCATE(sst1d        )
!PK   DEALLOCATE(sst1ave      )
!PK   DEALLOCATE(sst          )
!PK   DEALLOCATE(Recon_sst    )
!PK   DEALLOCATE(Recon_sst2   )
!PK   DEALLOCATE(Filter_sstENSO)
!PK   DEALLOCATE(wave         )
!PK   DEALLOCATE(SCALE        )
!PK   DEALLOCATE(period       )
!PK   DEALLOCATE(Cdelta       )
!PK   DEALLOCATE(coi          )
!PK   DEALLOCATE(signif       )
!PK   DEALLOCATE(global_ws    )
!PK   DEALLOCATE(global_signif)
!PK   DEALLOCATE(fft_theor    )
!PK   DEALLOCATE(P_theor      )
!PK   DEALLOCATE(savg_dof     )
!PK   DEALLOCATE(savg_signif  )
!PK   PRINT*,'Finalize'
  END SUBROUTINE Finalize

END PROGRAM Main

